
  import {
    getAllNotification,
    getOneNotification,
    getTotNotification
  } from '../db_apis/mobile.notification.js';

  import { FAILED, NOT_FOUND, SUCCESS } from '../utils/status.js';
  
  // get all orders
  export async function getAllNotificationInfo(req, res, next) {
    try {
      const context = {};
      context.created_by = req.body.created_by;
      const rows = await getAllNotification(context);
  
      return rows
        ? res.status(200).json({
            len: rows.length,
            data: rows,
          })
        : res.status(404).json({
            len: 0,
            data: [],
          });
    } catch (error) {
      return next(error);
    }
  }

// get a single line for an order
export async function getSingleNotification(req, res, next) {
  try {

    const context = {};
    context.created_by = req.body.created_by;
    const row = await getOneNotification(context);
    return row
      ? res.status(200).json({ message: SUCCESS, data: row })
      : res.status(404).json({ message: NOT_FOUND, data: {} });
  } catch (error) {
    return next(error);
  }
}

// get all orders
export async function getATotNotificationInfo(req, res, next) {
  try {
    const context = {};
    context.created_by = req.body.created_by;
    
    const row = await getTotNotification(context);
    return row
      ? res.status(200).json({ message: SUCCESS, data: row })
      : res.status(404).json({ message: NOT_FOUND, data: {} });
  } catch (error) {
    return next(error);
  }
}
  