
import {
    getAllNotification,
    getOneNotification,
    getTotNotification,
    getSpecialRequestOrders,
    getSpecReqLines,
    deleteSpecReqOneLine,
    updateLine,
    cancelLine,
    submitOrder,
    updateOne,
    getTotalRequest,
    getTotalCancelRequest,
    getSpecialRequestApproveOrders,
    savePlumberRegistration,
    savePartialDelivery,
    getDiv,
    getZoneList,
    getBaseList,
    getZone,
    getPlumberStatusInfo,
    getPlumber,
    cancelPlumber,
    getPlumberEditInfo,
    updatePlumber,
    updateLineRemineQty,
    getDeliveryLines,
    requestPlumberList
  } from '../db_apis/special.request.js';

  import { FAILED, NOT_FOUND, SUCCESS } from '../utils/status.js';

  export async function getAllNotificationInfo(req, res, next) {
    try {
      const context = {};
      context.created_by = req.body.created_by;
      const rows = await getAllNotification(context);
  
      return rows
        ? res.status(200).json({
            len: rows.length,
            data: rows,
          })
        : res.status(404).json({
            len: 0,
            data: [],
          });
    } catch (error) {
      return next(error);
    }
  }

// get a single line for an order
export async function getSingleNotification(req, res, next) {
  try {

    const context = {};
    context.created_by = req.body.created_by;
    const row = await getOneNotification(context);
    return row
      ? res.status(200).json({ message: SUCCESS, data: row })
      : res.status(404).json({ message: NOT_FOUND, data: {} });
  } catch (error) {
    return next(error);
  }
}

export async function getATotNotificationInfo(req, res, next) {
  try {
    const context = {};
    context.created_by = req.body.created_by;
    
    const row = await getTotNotification(context);
    return row
      ? res.status(200).json({ message: SUCCESS, data: row })
      : res.status(404).json({ message: NOT_FOUND, data: {} });
  } catch (error) {
    return next(error);
  }
}

export async function getSalesPersonDiv(req, res, next) {
  try {
    const context = {};
    context.created_by = req.body.created_by;
    
    const row = await getDiv(context);
    return row
      ? res.status(200).json({ message: SUCCESS, data: row })
      : res.status(404).json({ message: NOT_FOUND, data: {} });
  } catch (error) {
    return next(error);
  }
}
export async function getSalesPersonZoneList(req, res, next) {
  try {
    const context = {};
    context.division_id = req.body.division_id;
    context.created_by = req.body.created_by;
    
    
    const row = await getZoneList(context);
    return row
      ? res.status(200).json({ message: SUCCESS, data: row })
      : res.status(404).json({ message: NOT_FOUND, data: {} });
  } catch (error) {
    return next(error);
  }
}
export async function getSalesPersonBaseList(req, res, next) {
  try {
    const context = {};
    context.zone_id = req.body.zone_id;
    context.created_by = req.body.created_by;
    
    
    const row = await getBaseList(context);
    return row
      ? res.status(200).json({ message: SUCCESS, data: row })
      : res.status(404).json({ message: NOT_FOUND, data: {} });
  } catch (error) {
    return next(error);
  }
}

export async function getSalesPersonZone(req, res, next) {
  try {
    const context = {};
    context.created_by = req.body.created_by;
    
    const row = await getZone(context);
    return row
      ? res.status(200).json({ message: SUCCESS, data: row })
      : res.status(404).json({ message: NOT_FOUND, data: {} });
  } catch (error) {
    return next(error);
  }
}


export async function getPlumberStatus(req, res, next) {
  try {
    const context = {};
    context.created_by = req.body.created_by;
    context.status = req.body.status;

    const rows = await getPlumberStatusInfo(context);

    return rows
      ? res.status(200).json({ len: rows.length, data: rows })
      : res.status(404).json({ len: 0, data: [] });
  } catch (error) {
    return next(error);
  }
}

export async function getPlumberInfo(req, res, next) {
  try {
    const context = {};
    context.plumber_id = parseInt(req.params.plumber_id);

    const row = await getPlumber(context);

    return row
      ? res.status(200).json({ message: SUCCESS, data: row })
      : res.status(404).json({ message: NOT_FOUND, data: {} });
  } catch (error) {
    return next(error);
  }
}

export async function getSpecialRequestOrderStatus(req, res, next) {
  try {
    const context = {};
    context.created_by = req.body.created_by;
    context.status = req.body.status;

    const rows = await getSpecialRequestOrders(context);

    return rows
      ? res.status(200).json({ len: rows.length, data: rows })
      : res.status(404).json({ len: 0, data: [] });
  } catch (error) {
    return next(error);
  }
}

export async function getSpecialRequestApproveOrderStatus(req, res, next) {
  try {
    const context = {};
    context.created_by = req.body.created_by;
    context.status = req.body.status;

    const rows = await getSpecialRequestApproveOrders(context);

    return rows
      ? res.status(200).json({ len: rows.length, data: rows })
      : res.status(404).json({ len: 0, data: [] });
  } catch (error) {
    return next(error);
  }
}
const plumberRegFromReq = (req) => {
  const newLine = {
    plumber_name: req.body.plumber_name,
    plumber_image: req.body.plumber_image,
    date_of_birth: req.body.date_of_birth,
    present_address: req.body.present_address,
    parmanent_address: req.body.parmanent_address,
    mobile_no: req.body.mobile_no,
    educ_qualification: req.body.educ_qualification,
    workplace: req.body.workplace,
    experience_year: parseInt(req.body.experience_year),
    family_name: req.body.married_status =='1'?req.body.family_name:"",
    marrige_day: req.body.married_status =='1'?req.body.marrige_day:"",
    nid_no: req.body.nid_no,
    zone: req.body.zone,
    created_by: req.body.created_by,
    status: 'PENDING',
    transaction_no: req.body.transaction_no,
    div_id: req.body.div_id,
    org_id: req.body.org_id,
    plumber_type: req.body.plumber_type,
    english_name: req.body.english_name,
    trans_type: parseInt(req.body.trans_type),
    married_status: req.body.married_status,
    zone_id: req.body.zone_id?req.body.zone_id:"",
    base_name: req.body.zone_id?req.body.base_name:"",
    base_id: req.body.zone_id?req.body.base_id:"",
    div_name: req.body.div_name?req.body.div_name:"",
  };
  return newLine;
};
export async function plumberRegistration(req, res, next) {
  try {
    const plumberRegistraion = plumberRegFromReq(req);

    const result = await savePlumberRegistration(plumberRegistraion);
    return result
      ? res.status(200).json({ status: SUCCESS, data: result })
      : res
          .status(501)
          .json({ status: FAILED, message: 'Plumber Registration Failed.' });
  } catch (error) {
    return next(error);
  }
}

// export async function partialDeliveryCreate(req, res, next) {
//   try {
//     let listOfQty = req.body.listOfQty
//     let listOfDate = req.body.listOfDate
//     const insertedQty = listOfQty.filter(value => value > 0);
//     const indices = [];
//     for (let i = 0; i < listOfQty.length; i++) {
//       if (listOfQty[i] > 0) {
//         indices.push(i);
//       }
//     }
//     const insertedDate = indices.map(index => listOfDate[index]);
//     // loop start here 
//     for (let i = 0; i < insertedQty.length; i++) {
//       if (insertedQty[i] > 0) {
//       const context = {};
//     context.ma_order_id = req.body.ma_order_id;
//     context.ma_line_id = req.body.ma_line_id;
//     context.partial_date = insertedDate[i];
//     context.partial_qty = insertedQty[i];
//     const result = await savePartialDelivery(context);
//       }
//     }

//     //const result = await savePartialDelivery(context);
//     const result = [];
//     return result
//       ? res.status(200).json({ status: SUCCESS, data: result })
//       : res
//           .status(501)
//           .json({ status: FAILED, message: 'Plumber Registration Failed.' });
//   } catch (error) {
//     return next(error);
//   }
// }

export async function partialDeliveryCreate(req, res, next) {
  try {
    
   const partialDeliveryInfo =  req.body.inputFields;
    // loop start here 
    for (let i = 0; i < partialDeliveryInfo.length; i++) {
     
    const context = {};
    context.ma_order_id = req.body.ma_order_id;
    context.ma_line_id = req.body.ma_line_id;
    context.partial_date = partialDeliveryInfo[i].delivery_date;
    context.partial_qty = partialDeliveryInfo[i].delivery_qty;
    context.created_by = req.body.created_by;
    context.item_code = req.body.item_code;
    //context.sum_delivery_qty = parseInt(req.body.sum_delivery_qty);
    const result = await savePartialDelivery(context);
    context.ma_line_id = req.body.ma_line_id;
    context.created_by = req.body.created_by;
    context.per_deli_at =  new Date();
    context.sum_delivery_qty = parseInt(req.body.sum_delivery_qty);
    const result2 = await updateLineRemineQty(context);
    }

   

    //const result = await savePartialDelivery(context);
    const result = [];
    return result
      ? res.status(200).json({ status: SUCCESS, data: result })
      : res
          .status(501)
          .json({ status: FAILED, message: 'Plumber Registration Failed.' });
  } catch (error) {
    return next(error);
  }
}

// get special request order line
export async function getSpecReqOrderWiseLines(req, res, next) {
  try {
    const context = {};
    context.ma_order_id = parseInt(req.params.ma_order_id);
    context.request_status = req.params.request_status;

    const rows = await getSpecReqLines(context);

    return rows
      ? res.status(200).json({ len: rows.length, data: rows })
      : res.status(404).json({ len: 0, data: [] });
  } catch (error) {
    return next(error);
  }
}

// delete special request single line
export async function deleteSpecialReqSingleLine(req, res, next) {
  try {
    const context = {};
    context.ma_order_id = parseInt(req.body.ma_order_id);
    context.ma_line_id = parseInt(req.body.ma_line_id);
    context.created_by = req.body.created_by;
    context.ed_cancle_date = new Date();

    const rows = await deleteSpecReqOneLine(context);

    // for cancel header suggested statsu
    // count total request 
    const totalReq = await getTotalRequest(context);
    const totalCanReq = await getTotalCancelRequest(context);
   if(totalReq.TOTAL_REQEST ==totalCanReq.TOTAL_CANCEL_REQEST){
    context.ma_order_id = parseInt(req.body.ma_order_id);
    context.sugg_fg = 'C';
    const result2 = await submitOrder(context);
   }

    return rows
      ? res.status(200).json({ status: SUCCESS, message: 'Line Item deleted' })
      : res.status(404).json({ status: FAILED, message: 'Failed to delete' });
  } catch (error) {
    return next(error);
  }
}
// special request order submit
export async function submitSpecReqOrderFromUser(req, res, next) {
  try {
    const context = {};
    context.ma_order_id = parseInt(req.body.ma_order_id);
    context.created_by = req.body.created_by;
    context.status = req.body.status;
    context.ed_sugg_app_at =  new Date();

    const result = await updateLine(context);
    return result
      ? res.json({
          status: SUCCESS,
          message: 'Order status successfully changed',
        })
      : res
          .status(404)
          .json({ status: FAILED, message: 'Order status update failed' });
  } catch (error) {
    return next(error);
  }
}

export async function submitOrderFromUser(req, res, next) {
  try {
    const context = {};
    context.ma_order_id = parseInt(req.body.ma_order_id);
    context.created_by = req.body.created_by;
    context.sugg_fg = req.body.status;
    context.ed_sugg_can_at =  new Date();

    const result2 = await submitOrder(context);
    const result = await cancelLine(context);
    return result
      ? res.json({
          status: SUCCESS,
          message: 'Order status successfully changed',
        })
      : res
          .status(404)
          .json({ status: FAILED, message: 'Order status update failed' });
  } catch (error) {
    return next(error);
  }
}

export async function updateSpecReqOrderLine(req, res, next) {
  try {
    const context = {};
    context.ma_order_id = parseInt(req.body.ma_order_id);
    context.ma_line_id = parseInt(req.body.ma_line_id);
    context.created_by = req.body.created_by;
    context.ed_sugg_app_at = new Date();

    const result = await updateOne(context);

    return result !== null
      ? res.json({ status: SUCCESS, result })
      : res
          .status(404)
          .json({ status: FAILED, message: 'Order line not updated' });
  } catch (error) {
    return next(error);
  }
}

export async function plumberRequestCancle(req, res, next) {
  try {
    const context = {};
    context.plumber_id = parseInt(req.body.plumber_id);
    context.status = req.body.status;
    context.submissionDate =  new Date();

    const result = await cancelPlumber(context);
    return result
      ? res.json({
          status: SUCCESS,
          message: 'Order status successfully changed',
        })
      : res
          .status(404)
          .json({ status: FAILED, message: 'Order status update failed' });
  } catch (error) {
    return next(error);
  }
}

export async function getPlumberEditInfoById(req, res, next) {
  try {
    const context = {};
    context.plumber_id = parseInt(req.body.plumber_id);

    const row = await getPlumberEditInfo(context);

    return row
      ? res.status(200).json({ message: SUCCESS, data: row })
      : res.status(404).json({ message: NOT_FOUND, data: {} });
  } catch (error) {
    return next(error);
  }
}
export async function updatePlumberInfo(req, res, next) {
  try {
    const context = {};

    context.plumber_id = parseInt(req.body.plumber_id);
    context.plumber_name = req.body.plumber_name;
    context.plumber_image = req.body.plumber_image;
    context.date_of_birth = req.body.date_of_birth;
    context.present_address = req.body.present_address;
    context.parmanent_address = req.body.parmanent_address;
    context.mobile_no = req.body.mobile_no;
    context.educ_qualification = req.body.educ_qualification;
    context.workplace = req.body.workplace;
    context.experience_year = parseInt(req.body.experience_year);
    context.family_name = req.body.marride_status =='1'?req.body.family_name:"";
    context.marrige_day = req.body.marride_status =='1' ?req.body.marrige_day:"";
    context.nid_no = req.body.nid_no;
    context.transaction_no = req.body.transaction_no;
    context.updated_by = req.body.created_by;
    context.updated_at =  new Date();
    context.plumber_type =  req.body.plumber_type;
    context.english_name =  req.body.english_name;
    context.trans_type =  req.body.trans_type;
    context.marride_status =  req.body.marride_status;
    context.div_id =  req.body.div_id?req.body.div_id:"";
    context.div_name =  req.body.div_name?req.body.div_name:"";
    context.zone_id =  req.body.zone_id?req.body.zone_id:"";
    context.zone =  req.body.zone?req.body.zone:"";
    context.base_id =  req.body.base_id?req.body.base_id:"";
    context.base_name =  req.body.div_name?req.body.base_name:"";

    const result = await updatePlumber(context);

    return result
      ? res.json({
          status: SUCCESS,
          message: 'Plumber Status status successfully changed',
        })
      : res
          .status(404)
          .json({ status: FAILED, message: 'Plumber status update failed' });
  } catch (error) {
    return next(error);
  }
}

export async function getDeliveryDateWiseLines(req, res, next) {
  try {
    const context = {};
    context.ma_line_id = parseInt(req.params.ma_line_id);

    const rows = await getDeliveryLines(context);

    return rows
      ? res.status(200).json({ len: rows.length, data: rows })
      : res.status(404).json({ len: 0, data: [] });
  } catch (error) {
    return next(error);
  }
}
export async function getRequestPlumber(req, res, next) {
  try {
    const context = {};
    context.created_by = req.body.created_by;
    context.status = req.body.status;

    const rows = await requestPlumberList(context);

    return rows
      ? res.status(200).json({ len: rows.length, data: rows })
      : res.status(404).json({ len: 0, data: [] });
  } catch (error) {
    return next(error);
  }
}

  