import { simpleExecute } from '../services/database.js';

const baseQuery = `SELECT BM.RECEIPT_METHOD_ID          "receipt_method_id",
                    BM.REMIT_BANK_ACCT_USE_ID     "remit_bank_acct_use_id",
                    BM.BANK_ACCOUNT_ID            "id",
                    BM.BANK_NAME                  "title",
                    BM.BANK_ACCOUNT_NAME          "account_name",
                    BM.BANK_ACCOUNT_NUM           "bank_account_number",
                    BM.BANK_BRANCH_NAME           "branch_name",
                    BM.ORG_ID                     "org_id",
                    BM.SHORT_BANK_NAME            "short_bank_name"
                    FROM APPS.XXBANKMOBILE_APPS@SALES BM`
export async function get(context) {
  let query = baseQuery;
  const binds = {};

  if (context.org_id) {
    binds.org_id = context.org_id;
    query += `\nWHERE BM.ORG_ID = :org_id`;
    query += `\nAND BM.BANK_ACCOUNT_ID NOT IN (SELECT EL.BANK_ACCOUNT_ID FROM XX_BANK_ACC_EXC_LIST EL)`;
  }
  
  const result = await simpleExecute(query, binds);
  return result.rows !== null ? result.rows : null;
}


export async function getById(id) {
  const result = await simpleExecute(`${baseQuery} WHERE ID = :id`, { id });
  return result.rows.length > 0 ? result.rows[0] : null;
}


export async function getSingleBank(context) {
  let query = baseQuery;
  const binds = {};

  if (context.id) {
    binds.id = context.id;

    query += `\nWHERE BANK_ACCOUNT_ID = :id`;
  }
  
  const result = await simpleExecute(query, binds);
  return result.rows.length > 0 ? result.rows[0] : null;
}