//shadi
import { Router } from 'express';
import {
    getCustomerList,
    getCustomerInfo,
    insertOneCustomer,
    getApprovedCustomerList,
    getApprovedAvailableCustomerList,
    getApprovedCustomerInfo,
    insertShedule,
    checkSheduleIsIn,
    getSheduleByEmployeeDate,
    getCurrMonthShedule,
    updateSheduleCancel,
    updateSheduleComplete,
    getSheduleCount
} from '../../controllers/location.controller.js';
import {
    authProtection
} from '../../controllers/mobile.auth.controller.js';

const v1LocationRouter = Router();

v1LocationRouter.post('/v1/mobile/getCustomerList', authProtection, getCustomerList);
v1LocationRouter.post('/v1/mobile/getCustomerInfo', authProtection, getCustomerInfo);
v1LocationRouter.post('/v1/mobile/insertOneCustomer', authProtection, insertOneCustomer); //insert

v1LocationRouter.post('/v1/mobile/getApprovedAvailableCustomerList', authProtection, getApprovedAvailableCustomerList);
v1LocationRouter.post('/v1/mobile/getApprovedCustomerInfo', authProtection, getApprovedCustomerInfo);
v1LocationRouter.post('/v1/mobile/checkSheduleIsIn', authProtection, checkSheduleIsIn);
v1LocationRouter.post('/v1/mobile/insertShedule', authProtection, insertShedule); //insert

v1LocationRouter.post('/v1/mobile/getApprovedCustomerList', authProtection, getApprovedCustomerList);
v1LocationRouter.post('/v1/mobile/getSheduleByEmployeeDate', authProtection, getSheduleByEmployeeDate);

// v1LocationRouter.post('/v1/mobile/getCurrDateShedule', authProtection, getCurrDateShedule);
v1LocationRouter.post('/v1/mobile/getCurrMonthShedule', authProtection, getCurrMonthShedule);

v1LocationRouter.post('/v1/mobile/updateSheduleCancel', authProtection, updateSheduleCancel); //update
v1LocationRouter.post('/v1/mobile/updateSheduleComplete', authProtection, updateSheduleComplete); //update

v1LocationRouter.post('/v1/mobile/getSheduleCount', authProtection, getSheduleCount);


export { v1LocationRouter };