import { Router } from 'express';
import {
  generateOtp,
  login,
  setPassword,
  verifyUserOtp,
  changePolicyStatus,
  approveMobleUser,
  meetingCheck,
} from '../../controllers/mobile.auth.controller.js';

const v1MobileAuthRouter = Router();

v1MobileAuthRouter.post('/v1/mobile/auth/generate-otp', generateOtp);
v1MobileAuthRouter.post('/v1/mobile/auth/verify-otp', verifyUserOtp);
v1MobileAuthRouter.post('/v1/mobile/auth/password', setPassword);
v1MobileAuthRouter.post('/v1/mobile/auth/change-policy-status', changePolicyStatus);
v1MobileAuthRouter.get('/v1/mobile/auth/approve-mobile-user/:userId/:userGrpId/:userLvlId/:activeStatus', approveMobleUser);
v1MobileAuthRouter.post('/v1/mobile/auth/login', login);
v1MobileAuthRouter.post('/v1/mobile/auth/check-meeting', meetingCheck);

export { v1MobileAuthRouter };
