import { Router } from 'express';
import { authProtection } from '../../controllers/mobile.auth.controller.js';
import {
  getAllNotificationInfo,
  getSingleNotification,
  getATotNotificationInfo,
  getSpecialRequestOrderStatus,
  getSpecReqOrderWiseLines,
  deleteSpecialReqSingleLine,
  submitSpecReqOrderFromUser,
  submitOrderFromUser,
  updateSpecReqOrderLine,
  getSpecialRequestApproveOrderStatus,
  plumberRegistration,
  partialDeliveryCreate,
  getSalesPersonDiv,
  getSalesPersonZone,
  getSalesPersonZoneList,
  getSalesPersonBaseList,
  getPlumberStatus,
  getPlumberInfo,
  plumberRequestCancle,
  getPlumberEditInfoById,
  updatePlumberInfo,
  getDeliveryDateWiseLines,
  getRequestPlumber
} from '../../controllers/special.request.controller.js';

const v1SpecialRequest = Router();

v1SpecialRequest.post('/v1/special/request/notification/all', authProtection, getAllNotificationInfo);
v1SpecialRequest.post('/v1/special/request/notification/totNotice', authProtection, getATotNotificationInfo);
v1SpecialRequest.post('/v1/notification/single-notification', authProtection, getSingleNotification);
v1SpecialRequest.post('/v1/special/request/order/status',authProtection,getSpecialRequestOrderStatus);
v1SpecialRequest.post('/v1/special/request/userBy/order/status',authProtection,getSpecialRequestApproveOrderStatus);
v1SpecialRequest.get('/v1/mobile/special/request/sales/:ma_order_id/lines/:request_status', authProtection, getSpecReqOrderWiseLines);
v1SpecialRequest.delete('/v1/mobile/special/request/sales/orders/lines/line',authProtection,deleteSpecialReqSingleLine);
v1SpecialRequest.patch('/v1/mobile/special/request/sales/orders/submit',authProtection,submitSpecReqOrderFromUser);
v1SpecialRequest.patch('/v1/special/request/orders/cancel',authProtection,submitOrderFromUser);
v1SpecialRequest.patch('/v1/special/request/orders/lines/line',authProtection, updateSpecReqOrderLine);
v1SpecialRequest.post('/v1/plumber/registration/create', authProtection, plumberRegistration);
v1SpecialRequest.post('/v1/partial/delivery/create', authProtection, partialDeliveryCreate);
v1SpecialRequest.post('/v1/get/sales/person/zone', authProtection, getSalesPersonZone);
v1SpecialRequest.post('/v1/get/sales/person/div', authProtection, getSalesPersonDiv);
v1SpecialRequest.post('/v1/get/sales/person/zoneList', authProtection, getSalesPersonZoneList);
v1SpecialRequest.post('/v1/get/sales/person/baseList', authProtection, getSalesPersonBaseList);
v1SpecialRequest.post('/v1/get/plumber/info/edit/byId', authProtection, getPlumberEditInfoById);
v1SpecialRequest.post('/v1/get/plumber/status', authProtection, getPlumberStatus);
v1SpecialRequest.get('/v1/get/plumber/info/:plumber_id', authProtection, getPlumberInfo);

v1SpecialRequest.patch( '/v1/plumber/request/submit', authProtection,plumberRequestCancle);
v1SpecialRequest.patch('/v1/update/plumber/registration', authProtection, updatePlumberInfo);
v1SpecialRequest.get('/v1/partial/delivery/:ma_line_id/lines',authProtection,getDeliveryDateWiseLines);
v1SpecialRequest.post('/v1/get/request/plumber', authProtection, getRequestPlumber);

export { v1SpecialRequest };
